kuangbin Prime Path

F - Prime Path


The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033 
1733 
3733 
3739 
3779 
8779 
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
 

题意:

给两个素数 num1 num2  要求将num1变成num2  ,每次变换只能变一个数字,花费为一,变换后的数字依旧为素数,求最小花费。

思路:欧拉筛之后,bfs 分别跑个十百千位上的数字,个位数字一定为奇数,千位数字必定不为零。

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <functional>
#include <iostream>
#include <queue>
using namespace std;
const int maxn=1e6+10;
int prime[maxn],pn;
bool noot[maxn];
void init(){
    pn=0;
    memset(noot,false,sizeof(noot));
    noot[1]=1;
    for (int i=2;i<maxn;i++){
        if(!noot[i])prime[pn++]=i;
        for (int j=0;j<pn&&i*prime[j]<maxn;j++){
            noot[i*prime[j]]=1;
            if(i%prime[j]==0) break;
        }
    }
}
struct node{
    int num,step;
}now,nxt;
int num1,num2;
int bfs(int x){
    bool vis[maxn];
    memset(vis,false,sizeof(vis));
    vis[x]=1;
    now.num=x;
    now.step=0;
    queue<node>q;
    q.push(now);
    while(!q.empty()){
        now=q.front();
        q.pop();
        if(now.num==num2) return now.step;
        for (int i=1;i<=9;i+=2){
            int num=now.num/10*10+i;
            if(!noot[num]&&!vis[num]){
                nxt.num=num;
                nxt.step=now.step+1;
                vis[num]=1;
                q.push(nxt);
            }
        }//个位
        for (int i=0;i<=9;i++){
            int num=now.num%10+(now.num/100*10+i)*10;
            if(!noot[num]&&!vis[num]){
                nxt.num=num;
                nxt.step=now.step+1;
                vis[num]=1;
                q.push(nxt);
            }
        }//十位;
        for (int i=0;i<=9;i++){
            int num=now.num%100+(now.num/1000*10+i)*100;
            if(!noot[num]&&!vis[num]){
                nxt.num=num;
                nxt.step=now.step+1;
                vis[num]=1;
                q.push(nxt);
            }
        }
        for (int i=1;i<=9;i++){
            int num=now.num%1000+i*1000;
            if(!noot[num]&&!vis[num]){
                nxt.num=num;
                nxt.step=now.step+1;
                vis[num]=1;
                q.push(nxt);
            }
        }
    }
    return -1;
}
int main(){
    init();
    int t;
    scanf("%d",&t);
    while(t--){
        scanf("%d%d",&num1,&num2);
        int ans=bfs(num1);
        if(ans>=0) printf("%d\n",ans);
        else printf("Impossible\n");
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/acerkoo/article/details/80303323